
public class HammingDistance {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		//Hamming-Distanz wird nur berechnet, wenn min. zwei Strings uebergeben wurden
		if (args.length == 0) {
			System.out.println("Es wurden keine Strings uebergeben.");
		} else if (args.length == 1) {
			System.out.println("Es muessen min. zwei Strings uebergeben werden.");
		} else {
			// Die For-Schleifen fuehren dazu, dass alle paarweisen Distanzen berechnet werden. 
			for (int i = 0; i < args.length-1; i++) {
				for (int j = i+1; j < args.length; j++) {
					// Haben zwei Strings die gleiche Laenge, wird ihre Distanz berechnet.
					if (hasSameLength(args[i], args[j])){
						computeHammingDistance(args[i], args[j]);
					} else {
						System.out.println("Die Strings "+args[i]+" und "+args[j]+" haben nicht die" +
								" gleiche Laenge.");
					}
				}
			}
		}
	}

	//Ueberprueft, ob die beiden Strings auch die selbe Laenge haben, 
	//da die Hamming-Distanz nur fuer Strings der selben Laenge
	//definiert ist.
	public static boolean hasSameLength(String x, String y) {
		if (x.length() == y.length()) {
			return true;
		} else {
			return false;
		}
	}
	
	//Berechnet die Hamming-Distanz von zwei Strings gleicher Laenge.
	public static void computeHammingDistance(String x, String y) {
		int distance = 0;
		for (int i = 0; i < x.length(); i++){
			if (x.charAt(i) != y.charAt(i)) {
				distance ++;
			}
		}
		System.out.println("Die Hamming-Distanz zwischen "+x+" und "+y+" ist "+distance+".");
	}
	
}
